# DB Paribhasha
[![Elucidata](http://blog.elucidata.io/wp-content/uploads/2017/09/Group@2x-e1504269518759.png)](http://elucidata.io/)

A package for handling your database abstractions and schema

## Introduction

This python library handles all the database definitions made across all layers of the infrastrucure. This may include ORMs for relational, as well as wrappers around non-relational database modelling schemes.

Currently, this package supports PostGres and DynamoDB.

This project provides the following functionality:

- DB Base classes
- Defining ORM models

## Getting Started

This library consists of multiple modules, defining database mappers.

In your core code, you can import any definition or model and utilize it. For example, to create a DynamoDB table using Pynamo, you can use the following code:

```
from db_paribhasha import PynamoBaseModel

class MyDynamoTable(PynamoBaseModel):
    """
    Some class definition
    """
    class Meta:
        table_name = constants.DYNAMO_TABLE
        region = os.getenv('REGION')

    org_id = NumberAttribute(hash_key=True)
...
```

The modules are extensively documented.

### Prerequisites

Elucidata's privately maintained pip server should be configured properly to
install via pip. Also, you need to be on the Elucidata's static IP for this to work.

In ~/.pip/pip.conf on Mac/Linux, add:

```
[global]
extra-index-url = http://54.245.179.143/
[install]
trusted-host=54.245.179.143
```

### Installing

Clone the repository or install using pip:

```
pip install --upgrade db_paribhasha
```

## Deployment

Just install cloud_resources as pip/python dependency on your code layer

## Built With

* Love

## Versioning

We use [SemVer](http://semver.org/) for versioning.

## Contributors
Pulkit Kumar - pulkit.kumar@elucidata.io

## License

This project is developed and maintained internally by Elucidata Inc.
