#!/usr/bin/env python
# -*- coding: utf-8 -*-
from builtins import object
import time

from pynamodb.attributes import  NumberAttribute, \
    JSONAttribute, UnicodeAttribute

from db_paribhasha import PynamoBaseModel, credentials


class UserRequestDynamoDB(PynamoBaseModel):
    #TODO Hash key to be revised
    """
    UserRequest Dynamo DB model for Pre Login data
    Model is created using pynamoDB library.
    """
    class Meta(object):
        table_name = credentials.DYNAMO_USER_REQUEST_TABLE
        region = credentials.DYNAMO_REGION

    email = UnicodeAttribute(hash_key=True)
    created_time = NumberAttribute(null=False, 
                                  default=int(round(time.time() * 1000)))
    org = UnicodeAttribute(null=True)
    designation = UnicodeAttribute(null=True)
    demo_time = UnicodeAttribute(null=True)
    other_data = JSONAttribute(null=True)
    query_type = UnicodeAttribute(null=False)
